#pragma once

#include <stdint.h>

struct __attribute__((packed)) bmp_header {
    uint16_t type;
    uint32_t size;
    uint16_t reserved1;
    uint16_t reserved2;
    uint32_t data_offset;
};
_Static_assert(sizeof(struct bmp_header) == 14, "incorrect sizeof(struct bmp_header");

struct __attribute__((packed)) bitmapinfoheader {
    uint32_t size;
    int32_t width, height;
    uint16_t planes;
    uint16_t bpp;
    uint32_t compression;
    uint32_t raw_size;
    int32_t horizontal_resolution, vertical_resolution;
    uint32_t colours_in_palette;
    uint32_t important_colors;
};
_Static_assert(sizeof(struct bitmapinfoheader) == 40, "incorrect sizeof(struct bitmapinfoheader");

struct __attribute__((packed)) pixel24 {
    uint8_t b, g, r;
};
_Static_assert(sizeof(struct pixel24) == 3, "incorrect sizeof(struct pixel24)");
